/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  3 Oct 2007 9:26:45 am

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.10

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
//[/Headers]

#include "MainWindow.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...
#include "TagFactory.h"
#include "app.h"

#include <iostream>

using namespace std;
//[/MiscUserDefs]

//==============================================================================
MainWindow::MainWindow (const String& commandLine)
    : playButton (0),
      stopButton (0),
      songTitleLabel (0),
      songTimeLabel (0),
      songPosition (0),
      sourceSelection (0),
      songList (0),
      albumCover (0)
{
    addAndMakeVisible (playButton = new TextButton (T("playButton")));
    playButton->setButtonText (T("Play"));
    playButton->addButtonListener (this);
    playButton->setColour (TextButton::buttonColourId, Colours::green);
    playButton->setColour (TextButton::buttonOnColourId, Colours::green);

    addAndMakeVisible (stopButton = new TextButton (T("stopButton")));
    stopButton->setButtonText (T("Stop"));
    stopButton->addButtonListener (this);
    stopButton->setColour (TextButton::buttonColourId, Colour (0xff6363c6));
    stopButton->setColour (TextButton::buttonOnColourId, Colour (0xff6363c6));

    addAndMakeVisible (songTitleLabel = new Label (T("songTitleLabel"),
                                                   T("<No Song>")));
    songTitleLabel->setFont (Font (15.0000f, Font::bold));
    songTitleLabel->setJustificationType (Justification::centredLeft);
    songTitleLabel->setEditable (false, false, false);
    songTitleLabel->setColour (TextEditor::textColourId, Colours::black);
    songTitleLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));

    addAndMakeVisible (songTimeLabel = new Label (T("songTimeLabel"),
                                                  T("0:00/0:00")));
    songTimeLabel->setFont (Font (15.0000f, Font::plain));
    songTimeLabel->setJustificationType (Justification::centredLeft);
    songTimeLabel->setEditable (false, false, false);
    songTimeLabel->setColour (TextEditor::textColourId, Colours::black);
    songTimeLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));

    addAndMakeVisible (songPosition = new Slider (T("songPosition")));
    songPosition->setRange (0, 1, 0);
    songPosition->setSliderStyle (Slider::LinearHorizontal);
    songPosition->setTextBoxStyle (Slider::NoTextBox, false, 80, 20);
    songPosition->addListener (this);

    addAndMakeVisible (sourceSelection = new FolderList (this));
    sourceSelection->setName (T("sourceSelection"));

    addAndMakeVisible (songList = new SongList (this));
    songList->setName (T("songList"));

    addAndMakeVisible (albumCover = new AlbumCoverDisplay2());
    albumCover->setName (T("albumCover"));


    //[UserPreSize]

	appName = T("NiallTunes");

	//Update sandbox with any songs passed in on the command line.
	{
		StringArray tempArr;
		String tempstr = commandLine;
		String tempstr2;

		while((tempstr.indexOfChar(' ') != -1) || (tempstr.length() > 0))
		{
			if(tempstr.indexOfChar(' ') != -1)
				tempstr2 = tempstr.substring(0, tempstr.indexOfChar(' '));
			else
				tempstr2 = tempstr;

			tempArr.add(tempstr2);
			if(tempstr.indexOfChar(' ') == -1)
				tempstr = T("");
			else
				tempstr = tempstr.substring(tempstr.indexOfChar(' ')+1);
		}

		songList->filesDropped(tempArr, 0, 0);
	}

	//Update songList according to the saved settings.
	loadSettings();

	/*sourceSelection->updateContent();
	sourceSelection->selectRow(0);*/

	//PortAudio stuff.
	if(Pa_Initialize() == paNoError)
	{
		const PaHostApiInfo *apiInfo;
		PaHostApiIndex apiIndex;
		PaDeviceIndex deviceIndex;
		PaStreamParameters streamParams;
		PaError err;

#ifdef WIN32
		apiIndex = Pa_HostApiTypeIdToHostApiIndex(paDirectSound);
#else
		apiIndex = Pa_HostApiTypeIdToHostApiIndex(paJACK);
#endif
		apiInfo = Pa_GetHostApiInfo(apiIndex);
		deviceIndex = Pa_HostApiDeviceIndexToDeviceIndex(apiIndex,
														 apiInfo->defaultOutputDevice);

		streamParams.device = apiInfo->defaultOutputDevice;
		streamParams.channelCount = 2;
		streamParams.sampleFormat = paFloat32;
		streamParams.suggestedLatency = 0.0;
		streamParams.hostApiSpecificStreamInfo = 0;

		samplerate = 44100.0;
		if(Pa_IsFormatSupported(NULL, &streamParams, samplerate) == paInvalidSampleRate)
			samplerate = 48000.0; //This is obviously a nasty hacky way of doing things.

		err = Pa_OpenStream(&audioStream,
							NULL,
							&streamParams,
							samplerate,
							0,
							paNoFlag,
							portAudioCallback,
							(void *)this);
		if(err != paNoError)
		{
			AlertWindow::showMessageBox(AlertWindow::WarningIcon,
										T("Audio Error"),
										T("Could not open PortAudio stream."));
		}
	}
	else
	{
		AlertWindow::showMessageBox(AlertWindow::WarningIcon,
									T("Audio Error"),
									T("Could not initialise PortAudio."));
	}

	songSource[0] = 0;
	songSource[1] = 0;
	activeSongSource = 0;
	audioBuffer = new AudioSampleBuffer(2, 2048);
	currentSong = 0;
	songSampleCount = 0;
	songUpdate = 0;
	paused = false;
	playing = false;
	sliderChanged = -1;
    //[/UserPreSize]

    setSize (800, 600);

    //[Constructor] You can add your own custom stuff here..
    //[/Constructor]
}

MainWindow::~MainWindow()
{
    //[Destructor_pre]. You can add your own custom destruction code here..
	saveSettings(sourceSelection->getSelectedFolder() == T("Sandbox"));
    //[/Destructor_pre]

    deleteAndZero (playButton);
    deleteAndZero (stopButton);
    deleteAndZero (songTitleLabel);
    deleteAndZero (songTimeLabel);
    deleteAndZero (songPosition);
    deleteAndZero (sourceSelection);
    deleteAndZero (songList);
    deleteAndZero (albumCover);

    //[Destructor]. You can add your own custom destruction code here..
	if(Pa_IsStreamActive(audioStream))
	{
		if(Pa_StopStream(audioStream) == paNoError)
		{
			App *app = (App *)(JUCEApplication::getInstance());

			songPlayer.stop();
			songPlayer.setSource(0);
			if(songSource[0])
				delete songSource[0];
			if(songSource[1])
				delete songSource[1];
			songSource[0] = 0;
			songSource[1] = 0;
		}
	}

	Pa_CloseStream(audioStream);

	Pa_Terminate();

	if(songSource[0])
		delete songSource[0];
	if(songSource[1])
		delete songSource[1];
	for(unsigned int i=0;i<songs.size();++i)
		delete songs[i];
	delete audioBuffer;
    //[/Destructor]
}

//==============================================================================
void MainWindow::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    g.fillAll (Colour (0xffeae2d4));

    //[UserPaint] Add your own custom painting code here..
    //[/UserPaint]
}

void MainWindow::resized()
{
    playButton->setBounds (2, 2, 62, 62);
    stopButton->setBounds (72, 9, 48, 48);
    songTitleLabel->setBounds (136, 10, getWidth() - 220, 24);
    songTimeLabel->setBounds (138, 32, 102, 24);
    songPosition->setBounds (248, 32, getWidth() - 320, 24);
    sourceSelection->setBounds (8, 72, 150, getHeight() - 79);
    songList->setBounds (168, 72, getWidth() - 176, getHeight() - 79);
    albumCover->setBounds (getWidth() - 64, 8, 56, 56);
    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}

void MainWindow::buttonClicked (Button* buttonThatWasClicked)
{
    //[UserbuttonClicked_Pre]
    //[/UserbuttonClicked_Pre]

    if (buttonThatWasClicked == playButton)
    {
        //[UserButtonCode_playButton] -- add your button handler code here..
		if(playButton->getButtonText() == T("Play"))
		{
			if(paused)
			{
				paused = false;
				playButton->setButtonText(T("Pause"));
				playButton->setColour(TextButton::buttonColourId,
									  Colours::orange.darker(0.1f));
				return;
			}

			if(songs.size() > 0)
			{
				paused = false;

				//Clear the song sources.
				if(songSource[0])
					delete songSource[0];
				if(songSource[1])
					delete songSource[1];
				songSource[0] = 0;
				songSource[1] = 0;

				if(currentSong >= songs.size())
					currentSong = 0;

				//Make sure songList's selection is honoured.
				if(songList->getSelectedSong() == -1)
					songList->setSelectedSong(currentSong);
				else if(songList->getSelectedSong() != currentSong)
					currentSong = songList->getSelectedSong();

				//Create the song sources.
				songSource[0] = new AudioFormatReaderSource(songs[currentSong],
															false);
				if((songs.size() > 1) && ((currentSong+1) < songs.size()))
				{
					songSource[1] = new AudioFormatReaderSource(songs[currentSong+1],
																false);
				}
				activeSongSource = 0;
				songPlayer.setSource(songSource[0],
									 0,
									 songs[currentSong]->sampleRate);

				//Get everything ready to start streaming audio.
				songPlayer.prepareToPlay(2048, 44100.0);
				songPlayer.start();
				audioBuffer->clear();
				songSampleCount = 0;
				if(Pa_StartStream(audioStream) == paNoError)
				{
					int tempint;
					double tempd;
					String tempstr;
					App *app = (App *)(JUCEApplication::getInstance());

					//Update songTitleLabel.
					tempstr << songList->getSelectedArtist();
					tempstr << T(": ");
					tempstr << songList->getSelectedTitle();
					songTitleLabel->setText(tempstr, false);
					tempstr << T(" - NiallTunes");
					app->getWindow()->setName(tempstr);
					tempstr = T("");

					//Update songTimeLabel.
					tempd = (double)songs[currentSong]->lengthInSamples;
					tempd /= songs[currentSong]->sampleRate;
					tempint = (int)(tempd - ((int)(tempd/60.0)*60));
					currentSongLength = T("/");
					currentSongLength << (int)(tempd/60.0);
					currentSongLength << T(":");
					if(tempint < 10)
						currentSongLength << T("0");
					currentSongLength << tempint;
					tempstr << T("0:00") << currentSongLength;
					songTimeLabel->setText(tempstr, false);
					songPosition->setValue(0.0, false);

					//Update albumCover.
					{
						//File phil = ((FileInputStream *)songs[currentSong]->input)->getFile();
						File phil(paths[currentSong]);

						albumCover->loadImage(phil.getFullPathName());
						albumCover->repaint();
					}

					//Update playButton.
					playButton->setButtonText(T("Pause"));
					playButton->setColour(TextButton::buttonColourId, Colours::orange.darker(0.1f));
					playing = true;
				}
				else
				{
					songPlayer.stop();

					AlertWindow::showMessageBox(AlertWindow::WarningIcon,
												T("Audio Error"),
												T("Could not start PortAudio stream."));
				}
			}
			else
			{
				AlertWindow::showMessageBox(AlertWindow::WarningIcon,
											T("Song Error"),
											T("No songs to play."));
			}
		}
		else
		{
			paused = true;

			playButton->setButtonText(T("Play"));
			playButton->setColour(TextButton::buttonColourId, Colours::green);
		}
        //[/UserButtonCode_playButton]
    }
    else if (buttonThatWasClicked == stopButton)
    {
        //[UserButtonCode_stopButton] -- add your button handler code here..
		if(Pa_IsStreamActive(audioStream))
		{
			if(Pa_StopStream(audioStream) == paNoError)
			{
				App *app = (App *)(JUCEApplication::getInstance());

				songPlayer.stop();
				songPlayer.setSource(0);
				if(songSource[0])
					delete songSource[0];
				if(songSource[1])
					delete songSource[1];
				songSource[0] = 0;
				songSource[1] = 0;

				paused = false;
				playButton->setButtonText(T("Play"));
				playButton->setColour(TextButton::buttonColourId, Colours::green);
				playing = false;

				//Update Labels
				songTitleLabel->setText(T("<No Song>"), false);
				app->getWindow()->setName(T("NiallTunes"));
				songTimeLabel->setText(T("0:00/0:00"), false);
				songPosition->setValue(0.0, false);

				//Update albumCover.
				albumCover->loadImage(T(""));
				albumCover->repaint();
			}
			else
			{
				AlertWindow::showMessageBox(AlertWindow::WarningIcon,
											T("Audio Error"),
											T("Could not stop PortAudio stream."));
			}
		}
        //[/UserButtonCode_stopButton]
    }

    //[UserbuttonClicked_Post]
    //[/UserbuttonClicked_Post]
}

void MainWindow::sliderValueChanged (Slider* sliderThatWasMoved)
{
    //[UsersliderValueChanged_Pre]
    //[/UsersliderValueChanged_Pre]

    if (sliderThatWasMoved == songPosition)
    {
        //[UserSliderCode_songPosition] -- add your slider handling code here..
		double tempd = songPosition->getValue();

		tempd *= ((double)songs[currentSong]->lengthInSamples/songs[currentSong]->sampleRate);
		songPlayer.setPosition(tempd);
		sliderChanged = (int)(songPosition->getValue() * (double)songPlayer.getTotalLength());
        //[/UserSliderCode_songPosition]
    }

    //[UsersliderValueChanged_Post]
    //[/UsersliderValueChanged_Post]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...

//------------------------------------------------------------------------------
void MainWindow::paintListBoxItem(int rowNumber,
								  Graphics& g,
								  int width,
								  int height,
								  bool rowIsSelected)
{
	//Draw blue gradient behind selected row.
	if(rowIsSelected)
	{
		GradientBrush basil(Colour(68, 71, 202).brighter(0.3f),
							0.0f,
							0.0f,
							Colour(68, 71, 202).darker(0.5f),
							0.0f,
							(float)height,
							false);

		g.setBrush(&basil);

		g.fillAll();
	}
	else if(rowNumber%2)
	{
		g.setColour(Colour(240, 240, 240));

		g.fillAll();
	}

	//Draw text.
	if(!rowIsSelected)
		g.setColour(Colours::black);
	else
		g.setColour(Colours::white);
	if(rowNumber == 0)
	{
		g.drawText(T("Sandbox"),
				   3,
				   0,
				   (width-6),
				   height,
				   Justification(Justification::centredLeft),
				   true);
	}
}

//------------------------------------------------------------------------------
void MainWindow::handleMessage(const Message& message)
{
	if(message.intParameter1 == PlaybackStopped)
		buttonClicked(stopButton);
	else if(message.intParameter1 == NextSong)
	{
		int tempint2;
		double tempd;
		String tempstr;
		int tempint = 1-activeSongSource;
		App *app = (App *)(JUCEApplication::getInstance());

		delete songSource[tempint];
		songSource[tempint] = 0;
		songSource[tempint] = new AudioFormatReaderSource(songs[currentSong+1],
														  false);
		songList->setSelectedSong(currentSong);
		songUpdate = 0;

		//Update songTitleLabel.
		tempstr << songList->getSelectedArtist();
		tempstr << T(": ");
		tempstr << songList->getSelectedTitle();
		songTitleLabel->setText(tempstr, false);
		tempstr << T(" - ") << appName;
		app->getWindow()->setName(tempstr);
		tempstr = T("");

		//Update songTimeLabel.
		tempd = (double)songs[currentSong]->lengthInSamples;
		tempd /= songs[currentSong]->sampleRate;
		tempint2 = (int)(tempd - ((int)(tempd/60.0)*60));
		currentSongLength = T("/");
		currentSongLength << (int)(tempd/60.0);
		currentSongLength << T(":");
		if(tempint2 < 10)
			currentSongLength << T("0");
		currentSongLength << tempint2;
		tempstr << T("0:00") << currentSongLength;
		songTimeLabel->setText(tempstr, false);
		songPosition->setValue(0.0, false);

		//Update albumCover.
		{
			//File phil = ((FileInputStream *)songs[currentSong]->input)->getFile();
			File phil(paths[currentSong]);

			albumCover->loadImage(phil.getFullPathName());
			albumCover->repaint();
		}
	}
	else if(message.intParameter1 == UpdateTime)
	{
		double tempd;
		String tempstr;

		tempd = (double)songSampleCount/44100.0;
		tempstr.printf(T("%d:%02d"),
					   (int)(tempd/60.0),
					   (int)(tempd - ((int)(tempd/60.0)*60)));
		tempstr << currentSongLength;
		songTimeLabel->setText(tempstr, false);
		songPosition->setValue(tempd/((double)songs[currentSong]->lengthInSamples/songs[currentSong]->sampleRate), false);
	}
	else
		handleMessage(message);
}

//------------------------------------------------------------------------------
int MainWindow::portAudioCallback(const void *input,
								  void *output,
								  unsigned long frameCount,
								  const PaStreamCallbackTimeInfo *timeInfo,
								  PaStreamCallbackFlags statusFlags,
								  void *userData)
{
	MainWindow *win = (MainWindow *)userData;

	if(win)
		win->getAudio((float *)output, frameCount);

	return 0;
}

//------------------------------------------------------------------------------
void MainWindow::getAudio(float *output, unsigned long numSamples)
{
	unsigned int i;
	float *bufLeft;
	float *bufRight;
	AudioSourceChannelInfo chanInfo;

	if(paused)
	{
		for(i=0;i<numSamples;++i)
		{
			output[i*2] = 0.0f;
			output[(i*2)+1] = 0.0f;
		}
		return;
	}

	if(sliderChanged > -1)
	{
		songSampleCount = sliderChanged;
		sliderChanged = -1;
	}

	//Make sure the buffer's not too small.
	if(numSamples > (unsigned)audioBuffer->getNumSamples())
		audioBuffer->setSize(2, numSamples);

	//Setup chanInfo.
	chanInfo.buffer = audioBuffer;
	chanInfo.startSample = 0;
	chanInfo.numSamples = numSamples;

	//Get audio.
	songPlayer.getNextAudioBlock(chanInfo);
	bufLeft = audioBuffer->getSampleData(0);
	bufRight = audioBuffer->getSampleData(1);

	//Copy audio to sound card.
	for(i=0;i<numSamples;++i)
	{
		output[i*2] = bufLeft[i];
		output[(i*2)+1] = bufRight[i];
		++songSampleCount;
	}

	if(songSampleCount >= songPlayer.getTotalLength())
	{
		++currentSong;
		if(currentSong >= songs.size())
		{
			Message *tempMess = new Message(PlaybackStopped, 0, 0, 0);

			postMessage(tempMess);
			currentSong = 0;
			songSampleCount = 0;
		}
		else
		{
			Message *tempMess = new Message(NextSong, 0, 0, 0);

			songSampleCount = 0;
			activeSongSource = (activeSongSource + 1)%2;
			if(songSource[activeSongSource] != 0)
			{
				songPlayer.setSource(songSource[activeSongSource],
									 0,
									 songs[currentSong]->sampleRate);
				songPlayer.prepareToPlay(2048, 44100.0);
				songPlayer.start();
				postMessage(tempMess);
			}
			else
			{
				Message *tempMess = new Message(PlaybackStopped, 0, 0, 0);

				postMessage(tempMess);
				currentSong = 0;
				songSampleCount = 0;
			}
		}
	}
	else
	{
		songUpdate += numSamples;
		if(songUpdate > 44100)
		{
			Message *tempMess = new Message(UpdateTime, 0, 0, 0);

			postMessage(tempMess);
			songUpdate = 0;
		}
	}
}

//------------------------------------------------------------------------------
unsigned int *MainWindow::addSongs(const StringArray& newSongs)
{
	int i;
	unsigned int *retval;

	if(newSongs.size() > 0)
		retval = new unsigned int[newSongs.size()];
	else
		retval = 0;

	for(i=0;i<newSongs.size();++i)
	{
		AudioFormatReader *tempReader = TagFactory::getReader(newSongs[i]);

		if(tempReader)
		{
			songs.push_back(tempReader);
			paths.push_back(newSongs[i]);
			if(sourceSelection->getSelectedFolder() == T("Sandbox"))
				sandboxPaths.push_back(newSongs[i]);

			retval[i] = (unsigned int)((double)tempReader->lengthInSamples/
									   (double)tempReader->sampleRate);
		}
		else
		{
			String tempstr;

			tempstr << T("Could not load this file type:");
			tempstr << newSongs[i];
			AlertWindow::showMessageBox(AlertWindow::WarningIcon,
										T("Song Error"),
										tempstr);
			retval[i] = 0;
		}
	}

	return retval;
}

//------------------------------------------------------------------------------
void MainWindow::changeSong(int songIndex)
{
	//Reset if we're currently playing.
	if(paused)
		buttonClicked(playButton);
	if(playing)
		buttonClicked(stopButton);

	//Play new song.
	buttonClicked(playButton);
}

//------------------------------------------------------------------------------
void MainWindow::removeSongs(const SparseSet<int>& oldSongs)
{
	int i;

	for(i=(oldSongs.size()-1);i>=0;--i)
	{
		delete songs[oldSongs[i]];
		songs.erase(songs.begin() + oldSongs[i]);
		paths.erase(paths.begin() + oldSongs[i]);
		if(sourceSelection->getSelectedFolder() == T("Sandbox"))
			sandboxPaths.erase(sandboxPaths.begin() + oldSongs[i]);
	}
}

//------------------------------------------------------------------------------
void MainWindow::loadFolder(const String& path)
{
	unsigned int i;
	StringArray folderFiles;

	songList->clear();

	for(i=0;i<songs.size();++i)
		delete songs[i];
	songs.clear();

	if(path == T("Sandbox"))
	{
		StringArray songPaths;

		paths.clear();

		for(i=0;i<sandboxPaths.size();++i)
			songPaths.add(sandboxPaths[i]);
		sandboxPaths.clear();

		songList->filesDropped(songPaths, 0, 0);
	}
	else
	{
		File phil(path);
		DirectoryIterator dirIt(phil, false);

		if(lastSelectedFolder == T("Sandbox"))
		{
			sandboxPaths.clear();
			sandboxPaths.insert(sandboxPaths.end(), paths.begin(), paths.end());
		}
		paths.clear();

		while(dirIt.next())
		{
			File phil2 = dirIt.getFile();
			String philExtension;

			if(phil2.existsAsFile())
			{
				philExtension = phil2.getFileExtension();
				if((philExtension == T(".wav")) ||
				   (philExtension == T(".aif")) ||
				   (philExtension == T(".aiff")) ||
				   (philExtension == T(".flac")) ||
				   (philExtension == T(".ogg")) ||
				   (philExtension == T(".mp3")))
				{
					folderFiles.add(phil2.getFullPathName());
				}
			}
		}
		songList->filesDropped(folderFiles, 0, 0);
	}

	lastSelectedFolder = sourceSelection->getSelectedFolder();
}

//------------------------------------------------------------------------------
void MainWindow::addSandboxSongs(const std::vector<String>& newSongs)
{
	sandboxPaths.insert(sandboxPaths.end(),
						newSongs.begin(),
						newSongs.end());
	sandboxPaths.size();
}

//------------------------------------------------------------------------------
const StringArray MainWindow::getSelectedSongs() const
{
	int i;
	StringArray retval;
	const SparseSet<int> rows = songList->getSelectedSongs();

	for(i=0;i<rows.size();++i)
		retval.add(paths[rows[i]]);

	return retval;
}

//------------------------------------------------------------------------------
void MainWindow::loadSettings(bool ignoreFolders, bool startup)
{
	int i;
	File phil = File::getSpecialLocation(File::userHomeDirectory).getChildFile(T(".NiallTunes"));

	if(phil.existsAsFile())
	{
		XmlDocument doc(phil);
		XmlElement *root = doc.getDocumentElement();
		XmlElement *tempEl = 0;

		if(root)
		{
			StringArray sandboxFiles;
			StringArray folders;

			if(root->hasTagName(T("NiallTunes")))
			{
				tempEl = root->getFirstChildElement();
				while(tempEl)
				{
					if(tempEl->hasTagName(T("Sandbox")))
						sandboxFiles.add(tempEl->getStringAttribute(T("path")));
					else if((tempEl->hasTagName(T("Folder"))) && (!ignoreFolders))
						folders.add(tempEl->getStringAttribute(T("path")));

					tempEl = tempEl->getNextElement();
				}
			}

			if(sandboxFiles.size() > 0)
				songList->filesDropped(sandboxFiles, 0, 0);
			if(folders.size() > 0)
				sourceSelection->filesDropped(folders, 0, 0);

			if(startup)
			{
				for(i=0;i<paths.size();++i)
					sandboxPaths.push_back(paths[i]);
			}

			delete root;
		}
	}
}

//------------------------------------------------------------------------------
void MainWindow::saveSettings(bool sandbox)
{
	unsigned int i;
	XmlElement root(T("NiallTunes"));
	const vector<String>& folders = sourceSelection->getFolders();

	for(i=0;i<sandboxPaths.size();++i)
	{
		XmlElement *tempEl = new XmlElement(T("Sandbox"));
		String tempstr = sandboxPaths[i];

		tempEl->setAttribute(T("path"), tempstr);
		root.addChildElement(tempEl);
	}
	for(i=0;i<folders.size();++i)
	{
		XmlElement *tempEl = new XmlElement(T("Folder"));

		tempEl->setAttribute(T("path"), folders[i]);
		root.addChildElement(tempEl);
	}
	root.writeToFile(File::getSpecialLocation(File::userHomeDirectory).getChildFile(T(".NiallTunes")),
					 T(""));
}
//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Jucer information section --

    This is where the Jucer puts all of its metadata, so don't change anything in here!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="MainWindow" componentName=""
                 parentClasses="public Component, public ListBoxModel, public DragAndDropContainer"
                 constructorParams="const String& commandLine" variableInitialisers="" snapPixels="8" snapActive="1"
                 snapShown="1" overlayOpacity="0.330000013" fixedSize="0" initialWidth="800"
                 initialHeight="600">
  <BACKGROUND backgroundColour="ffeae2d4"/>
  <TEXTBUTTON name="playButton" id="5c5877fb6ff60cf5" memberName="playButton"
              virtualName="" explicitFocusOrder="0" pos="2 2 62 62" bgColOff="ff008000"
              bgColOn="ff008000" buttonText="Play" connectedEdges="0" needsCallback="1"
              radioGroupId="0"/>
  <TEXTBUTTON name="stopButton" id="fe18942317367260" memberName="stopButton"
              virtualName="" explicitFocusOrder="0" pos="72 9 48 48" bgColOff="ff6363c6"
              bgColOn="ff6363c6" buttonText="Stop" connectedEdges="0" needsCallback="1"
              radioGroupId="0"/>
  <LABEL name="songTitleLabel" id="9ea9999d1f7827ba" memberName="songTitleLabel"
         virtualName="" explicitFocusOrder="0" pos="136 10 220M 24" edTextCol="ff000000"
         edBkgCol="0" labelText="&lt;No Song&gt;" editableSingleClick="0" editableDoubleClick="0"
         focusDiscardsChanges="0" fontname="Default font" fontsize="15"
         bold="1" italic="0" justification="33"/>
  <LABEL name="songTimeLabel" id="b3ae15f3608a59f8" memberName="songTimeLabel"
         virtualName="" explicitFocusOrder="0" pos="138 32 102 24" edTextCol="ff000000"
         edBkgCol="0" labelText="0:00/0:00" editableSingleClick="0" editableDoubleClick="0"
         focusDiscardsChanges="0" fontname="Default font" fontsize="15"
         bold="0" italic="0" justification="33"/>
  <SLIDER name="songPosition" id="64d76e9092bc9a0e" memberName="songPosition"
          virtualName="" explicitFocusOrder="0" pos="248 32 320M 24" min="0"
          max="1" int="0" style="LinearHorizontal" textBoxPos="NoTextBox"
          textBoxEditable="1" textBoxWidth="80" textBoxHeight="20" skewFactor="1"/>
  <GENERICCOMPONENT name="sourceSelection" id="473a9681b5ee595c" memberName="sourceSelection"
                    virtualName="" explicitFocusOrder="0" pos="8 72 150 79M" class="FolderList"
                    params="this"/>
  <GENERICCOMPONENT name="songList" id="9713dc7ff8b53968" memberName="songList" virtualName=""
                    explicitFocusOrder="0" pos="168 72 176M 79M" class="SongList"
                    params="this"/>
  <GENERICCOMPONENT name="albumCover" id="fbeb152ca86c22ce" memberName="albumCover"
                    virtualName="" explicitFocusOrder="0" pos="64R 8 56 56" class="AlbumCoverDisplay2"
                    params=""/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif
