/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  3 Oct 2007 9:26:45 am

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.10

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

#ifndef __JUCER_HEADER_MAINWINDOW_MAINWINDOW_89F3954B__
#define __JUCER_HEADER_MAINWINDOW_MAINWINDOW_89F3954B__

//[Headers]     -- You can add your own extra header files here --
#include "AlbumCoverDisplay2.h"
#include "SongList.h"
#include "FolderList.h"

#include "portaudio.h"
#include "juce.h"
//[/Headers]



//==============================================================================
/**
                                                                    //[Comments]
    An auto-generated component, created by the Jucer.

    Describe your class and how it works here!
                                                                    //[/Comments]
*/
class MainWindow  : public Component,
                    public ListBoxModel,
                    public DragAndDropContainer,
                    public ButtonListener,
                    public SliderListener
{
public:
    //==============================================================================
    MainWindow (const String& commandLine);
    ~MainWindow();

    //==============================================================================
    //[UserMethods]     -- You can add your own custom methods in this section.

	///	Returns the number of elements in the sourceSelection ListBox.
	int getNumRows() {return 1;};
	///	Draws the sourceSelection ListBox elements.
	void paintListBoxItem(int rowNumber,
						  Graphics& g,
						  int width,
						  int height,
						  bool rowIsSelected);
	///	Used to give the GUI thread certain notifications from the audio thread.
	void handleMessage(const Message& message);

	///	Our PortAudio callback.
	static int portAudioCallback(const void *input,
								 void *output,
								 unsigned long frameCount,
								 const PaStreamCallbackTimeInfo *timeInfo,
								 PaStreamCallbackFlags statusFlags,
								 void *userData);
	///	The method called by portAudioCallback.
	void getAudio(float *output, unsigned long numSamples);

	///	Used to load songs into the app.
	/*!
		\return Returns the length of each song added.  If the song could not be
		loaded, it's length will be 0, and it should be removed from the
		Sandbox.

		It is the caller's responsibility to delete the returned array.
	 */
	unsigned int *addSongs(const StringArray& newSongs);
	///	Change which song we're playing/start playing the indexed song.
	void changeSong(int songIndex);
	///	Returns whether or not we're currently playing.
	bool isPlaying() const {return playing;};
	///	Removes the passed in songs.
	void removeSongs(const SparseSet<int>& oldSongs);
	///	Loads a folder of songs.
	void loadFolder(const String& path);
	///	Returns the vector of loaded song paths.
	const std::vector<String>& getPaths() const {return paths;};
	///	Adds songs to sandboxPaths.
	void addSandboxSongs(const std::vector<String>& newSongs);
	///	Returns the selected songs from SongList.
	const StringArray getSelectedSongs() const;

	///	Helper method to load settings from the user's saved settings file.
	void loadSettings(bool ignoreFolders = false, bool startup = false);
	///	Helper method to save settings to the user's saved settings file.
	void saveSettings(bool sandbox = false);

    //[/UserMethods]

    void paint (Graphics& g);
    void resized();
    void buttonClicked (Button* buttonThatWasClicked);
    void sliderValueChanged (Slider* sliderThatWasMoved);


    //==============================================================================
    juce_UseDebuggingNewOperator

private:
    //[UserVariables]   -- You can add your own custom variables in this section.

	///	IDs for the Messages sent from the audio thread to the GUI thread.
	enum
	{
		PlaybackStopped = 10000,//I don't know if I need to watch for conflicts
		NextSong,				//with other message types?
		UpdateTime
	};

	///	Our PortAudio stream.
	PaStream *audioStream;
	///	Readers for all the loaded songs.
	std::vector<AudioFormatReader *> songs;
	///	The paths for all the loaded songs.
	std::vector<String> paths;
	///	The paths for the sandbox songs.
	std::vector<String> sandboxPaths;

	///	User-customisable app name.
	String appName;

	///	Used to play the songs.
	AudioTransportSource songPlayer;
	///	Sources for the current and next songs.
	/*!
		We have 2 so that we can attempt to avoid gaps between songs.
	 */
	AudioFormatReaderSource *songSource[2];
	///	The currently-active songSource.
	int activeSongSource;
	///	Buffer for the audio callback.
	AudioSampleBuffer *audioBuffer;

	///	Which song we're currently listening to from songs.
	unsigned int currentSong;
	///	The length of the current song.
	String currentSongLength;
	///	Used to determine when we need to move on to the next song.
	int songSampleCount;
	///	Used to determine when to update the song time displays.
	int songUpdate;

	///	Whether or not we're currently paused.
	bool paused;
	///	Whether or not we're currently playing.
	bool playing;

	///	Used to make sure songSampleCount gets updated when the slider's dragged.
	int sliderChanged;

	///	The last selected folder.
	String lastSelectedFolder;

	///	The samplerate we're running at.
	double samplerate;
    //[/UserVariables]

    //==============================================================================
    TextButton* playButton;
    TextButton* stopButton;
    Label* songTitleLabel;
    Label* songTimeLabel;
    Slider* songPosition;
    FolderList* sourceSelection;
    SongList* songList;
    AlbumCoverDisplay2* albumCover;

    //==============================================================================
    // (prevent copy constructor and operator= being generated..)
    MainWindow (const MainWindow&);
    const MainWindow& operator= (const MainWindow&);
};


#endif   // __JUCER_HEADER_MAINWINDOW_MAINWINDOW_89F3954B__
