//	Metadata.h - Simple struct containing a song's metadata.
//	----------------------------------------------------------------------------
//	This file is part of NiallTunes, a basic music player.
//	Copyright (c) 2007 Niall Moody.
//
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#ifndef METADATA_H_
#define METADATA_H_

#include "juce.h"

///	Simple struct containing a song's metadata.
struct Metadata
{
	///	Default constructor.
	Metadata():
	length(210)
	{
	};

	///	Alternative constructor.
	Metadata(const String& songName,
			 const String& songArtist,
			 const String& songAlbum,
			 const String& songNumber,
			 unsigned int songLength):
	name(songName),
	artist(songArtist),
	album(songAlbum),
	trackNumber(songNumber),
	length(songLength)
	{
	}

	///	The song's title.
	String name;
	///	The song's artist.
	String artist;
	///	The song's album.
	String album;
	///	The song's track number.
	String trackNumber;
	///	The song's length in seconds.
	unsigned int length;
};

#endif
