//	NoMetadataTag.cpp - 'Tag' reader for file types w/out the relevant metadata.
//	----------------------------------------------------------------------------
//	This file is part of NiallTunes, a basic music player.
//	Copyright (c) 2007 Niall Moody.
//
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "NoMetadataTag.h"

using namespace std;

//------------------------------------------------------------------------------
NoMetadataTag::NoMetadataTag(const string& filepath):
Tag(filepath)
{
	string tempstr;

	//Track Number.
	{
		tempstr = filepath.substr(filepath.find_last_of('\\')+1);
		tempstr = tempstr.substr(0, tempstr.find_first_of('-'));
		setTrackNumber(tempstr);
	}

	//Title.
	{
		tempstr = filepath.substr(filepath.find_first_of('-')+1);
		tempstr = tempstr.substr(0, tempstr.find_last_of('.'));
		setTitle(tempstr);
	}

	//****TODO: Change this to the current user's name.****
	setArtist("...");
	setAlbum("");
}

//------------------------------------------------------------------------------
NoMetadataTag::~NoMetadataTag()
{
	
}
