//	NoMetadataTag.h - 'Tag' reader for file types w/out the relevant metadata.
//	----------------------------------------------------------------------------
//	This file is part of NiallTunes, a basic music player.
//	Copyright (c) 2007 Niall Moody.
//
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#ifndef NOMETADATATAG_H_
#define NOMETADATATAG_H_

#include "Tag.h"

///	'Tag' reader for file types w/out the relevant metadata.
/*!
	What this actually does is assume the file path has the following structure;
	<track no.>-<title>.<ext>
	and extracts the data accordingly.

	This is obviously a very specific case, but NoMetadataTag is only really
	intended for my own use of .wav files for my own songs.
 */
class NoMetadataTag : public Tag
{
  public:
	///	Constructor.
	NoMetadataTag(const std::string& filepath);
	///	Destructor.
	~NoMetadataTag();
};

#endif
