//	Tag.cpp - Base class for audio file tag readers.
//	----------------------------------------------------------------------------
//	This file is part of NiallTunes, a basic music player.
//	Copyright (c) 2007 Niall Moody.
//
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "Tag.h"

using namespace std;

//------------------------------------------------------------------------------
Tag::Tag(const string& filepath):
length(210)
{
	
}

//------------------------------------------------------------------------------
Tag::Tag(const Tag& other):
title(other.title),
artist(other.artist),
album(other.album),
trackNumber(other.trackNumber),
length(other.length)
{
	
}

//------------------------------------------------------------------------------
Tag::~Tag()
{
	
}

//------------------------------------------------------------------------------
void Tag::setTitle(const string& val)
{
	title = val;
}

//------------------------------------------------------------------------------
void Tag::setArtist(const string& val)
{
	artist = val;
}

//------------------------------------------------------------------------------
void Tag::setAlbum(const string& val)
{
	album = val;
}

//------------------------------------------------------------------------------
void Tag::setTrackNumber(const string& val)
{
	trackNumber = val;
}

//------------------------------------------------------------------------------
void Tag::setLength(unsigned int val)
{
	length = val;
}

//------------------------------------------------------------------------------
const string Tag::getFilename(const string& path)
{
	string tempstr;

#ifdef WIN32
	tempstr = path.substr(path.find_last_of("\\")+1);
#else
	tempstr = path.substr(path.find_last_of("/")+1);
#endif

	tempstr = tempstr.substr(0, tempstr.find_last_of("."));

	return tempstr;
}
