//	TagFactory.h - Singleton used to generate the correct tag reader based on
//				   file type.
//	----------------------------------------------------------------------------
//	This file is part of NiallTunes, a basic music player.
//	Copyright (c) 2007 Niall Moody.
//
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#ifndef TAGFACTORY_H_
#define TAGFACTORY_H_

#include "juce.h"

class Tag;

///	Singleton used to generate the correct tag reader based on file type.
namespace TagFactory
{
	///	Returns a filled out Tag if the file type was recognised, otherwise 0.
	Tag getMetadata(const String& filepath);
	///	Returns an AudioFormatReader for the file at filepath, if possible.
	/*!
		I wrote this before I noticed the AudioFormatManager class.
	 */
	AudioFormatReader *getReader(const String& filepath);
};

#endif
